function filimg = BOGaussian3D(img,s_x,s_y,s_z,std)
% BOGaussian3D - create 3D Gaussian kernel
% 
%   Boguslaw Obara, http://boguslawobara.net/
%
%   Version:
%       0.1 - 14/09/2007 First implementation
%%
siz = [s_x s_y s_z];
% construct the kernel;
[x,y,z] = meshgrid(-(siz(2)-1)/2:(siz(2)-1)/2,-(siz(1)-1)/2:(siz(1)-1)/2,-(siz(3)-1)/2:(siz(3)-1)/2);
ker = exp(-(x.*x + y.*y + z.*z)/(2*std*std));
ker = ker/sum(sum(sum(ker)));
filimg = convn(img,ker,'same');
end