function [imageSeeds nucleiPositions] = BOLoGDetector3D( imageIn, cellSize, resolutionXY, resolutionZ, scaleXY, scaleZ, thValue )
%% BOLoGDetector3D - calculate  3D log
% 
%   Boguslaw Obara, http://boguslawobara.net/
%
%   Version:
%       0.1 - 14/09/2007 First implementation
%%
fprintf('BOLoGDetector3D ... \n');
%% Setting the kernel and mask size
cellsizeXY = cellSize;
cellsizeZ = cellSize;
sizeXY = cellsizeXY/resolutionXY;
sizeZ = cellsizeZ/resolutionZ;

kernelsizeXY = round(sizeXY/2);
kernelsizeZ = round(((resolutionXY/resolutionZ)*sizeXY)/2);
kernelsizeZ = max(1, kernelsizeZ);   
kernelsizeSigma = 3;

masksizeXY = round(scaleXY*sizeXY);
masksizeZ = round(scaleZ*sizeZ);
%% Gauss filtering
%im_gauss = gaussian3Dfil(im_green, sizex, sizey, sizez, sigma);
imageGauss = BOGaussian3DFast(imageIn, kernelsizeXY, kernelsizeXY, kernelsizeZ, kernelsizeSigma);
%imageGauss = BOGaussian3DFastDiv(imageIn, kernelsizeXY, kernelsizeXY, kernelsizeZ, kernelsizeSigma); 
%% Seeds searching
[imageSeeds nucleiPositions] = BOSeedSearch(imageIn, imageGauss, masksizeXY, masksizeZ, thValue);
nucleiPositions(:,4) = (1:size(nucleiPositions,1))';
end
