%% TEST 
%% Clear variables and console
clear all; clc;
%% Read image data
load 'mat/image_small.mat'
imageNuclei = double(imageNuclei)/double(max(imageNuclei(:)));  
imageMembrane = double(imageMembrane)/double(max(imageMembrane(:)));
%% IMAGE PROCESSING
nucleiSize = 3.4;
thValue = 0.3; 
nucleiPositions = BONucleiDetector3D(imageNuclei, imageMembrane, nucleiSize, thValue, resolutionXY, resolutionZ, scaleXY, scaleZ);
%% Plot results
nucleus = nucleiPositions;
plane = 10; range = 2;
imageNucleiShow = zeros(size(imageNuclei,1),size(imageNuclei,2));
for i=1:size(imageNuclei,1)
    if i>=(plane-range) && i<=(plane+range)
        imageNucleiShow = max(imageNucleiShow,imageNuclei(:,:,i));
    end
end
figure,imagesc(imageNucleiShow), colormap gray;
hold on
for i=1:size(nucleus,1)
    if nucleus(i,3)>=(plane-range) && nucleus(i,3)<=(plane+range)
        plot(nucleus(i,2), nucleus(i,1), 'oy')
        hold on
    end
end